;***************************************************************************
;			Registering Font Example
;		 2005 by Mincho Georgiev /Shaka_Zulu/
;			  shaka_zulu@mail.bg
;***************************************************************************



; --=======================================================================--

      .586
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include Project.inc     ; local includes for this file
	

; --=======================================================================--

.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax


WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG
      LOCAL Wwd  :DWORD
      LOCAL Wht  :DWORD
      LOCAL Wtx  :DWORD
      LOCAL Wty  :DWORD

      invoke LoadIcon,hInst,500    ; icon ID
      mov hIcon, eax

      szText szClassName,"Project_Class"

      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                             or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      mov wc.hbrBackground,  COLOR_WINDOW+1
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
        invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc

      mov Wwd, 500
      mov Wht, 350

      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,Wwd,eax
      mov Wtx, eax

      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,Wht,eax
      mov Wty, eax

      invoke CreateWindowEx,WS_EX_LEFT,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_OVERLAPPEDWINDOW,
                            Wtx,Wty,Wwd,Wht,
                            NULL,NULL,
                            hInst,NULL
      mov   hWnd,eax

      invoke LoadMenu,hInst,600  ; menu ID
      invoke SetMenu,hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp


WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
	    LOCAL wWid   :DWORD
    LOCAL wHgt   :DWORD	
    .if uMsg == WM_COMMAND
    ;======== menu commands ========
        .if wParam == 1010
           invoke SetWindowText,hEdit,ADDR EmptyText
        
	.elseif wParam == 1011
		mov path,CTXT("All Files (*.*) ",0,"*.*",0)
		mov hFileName,OpenFileDlg(hWin,hInstance,"Choose a File",path)
		invoke LoadFile,hEdit,hFileName
	.elseif wParam == 1012
	       invoke SetFont
		
	.endif
    ;====== end menu commands ======

    .elseif uMsg == WM_CREATE
	m2m hOwner,hWin
	invoke EditCtrl,0,200,10,150,25,hWin,700
	mov hEdit,eax
	invoke SendMessage,hEdit,EM_SETLIMITTEXT,0,0
	invoke LoadFont
    .elseif uMsg == WM_SIZE
		invoke GetClientRect,hWin,ADDR Rct
      		 push Rct.right
       		 pop wWid
       		 push Rct.bottom          
       		 pop wHgt
       		 invoke MoveWindow,hEdit,0,0,wWid,wHgt,TRUE
    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
          mov hDC, eax
          invoke Paint_Proc,hWin,hDC
        invoke EndPaint,hWin,ADDR Ps
        return 0

    .elseif uMsg == WM_CLOSE
	.if ChangedFont==TRUE
	invoke RegisterFont
	.endif
	invoke ExitProcess,NULL
    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0 
	 .elseif uMsg == WM_SETFOCUS
        	invoke SetFocus,hEdit
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp


TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp


Paint_Proc proc hWin:DWORD, hDC:DWORD

    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

    return 0

Paint_Proc endp


end start
