;--====================================================================--
;--===		       Registry Access                               ==--
;--===          Copyright 2005 by Mincho Georgiev                    ==--
;--====================================================================--

;--===================================================================--
	SaveString PROTO :DWORD,:DWORD,:DWORD,:DWORD
	GetString  PROTO :DWORD,:DWORD,:DWORD
	SaveDword  PROTO :DWORD,:DWORD,:DWORD,:DWORD
	GetDword   PROTO :DWORD,:DWORD
	SaveBinary PROTO :DWORD,:DWORD,:DWORD,:DWORD
	GetBinary  PROTO :DWORD,:DWORD
;--===================================================================--

.code
;--====================string values==================================--

SaveString proc	lpszKey:DWORD,lpszValue:DWORD,
		lpszString:DWORD, dwStrLength:DWORD
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
	
		invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
			lpszKey,NULL,NULL,
			REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
			NULL,ADDR phkResult,ADDR lpdwDisposition 
		.if eax==ERROR_SUCCESS			
			invoke RegSetValueEx,phkResult,lpszValue,
				NULL,REG_SZ,lpszString,dwStrLength
			invoke RegCloseKey,phkResult	
			return TRUE
		.endif	
xor eax,eax	
ret
SaveString endp

GetString proc  lpszKey:DWORD,lpszValueName:DWORD,lpszBuffer:DWORD
		LOCAL dwStrLength:DWORD
		LOCAL phkResult	:DWORD
		LOCAL RType:DWORD
		LOCAL lpcbData :DWORD
		mov eax,REG_SZ
		mov RType,eax
		invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
			lpszKey,NULL,NULL,
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,
			NULL,ADDR phkResult,ADDR RType
		.if eax==ERROR_SUCCESS
			mov eax,REG_DWORD
			mov RType,eax
			invoke RegQueryValueEx,phkResult,lpszValueName,
				NULL,ADDR RType, lpszBuffer,
				 lpcbData 	
			invoke RegCloseKey,phkResult
			
		.endif

ret
GetString endp

;--======================dword values========================================--

SaveDword proc   dwKey:DWORD,dwValue:DWORD,
		 lpDword:DWORD,dwStrLength:DWORD
		
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
			dwKey,NULL,NULL,
			REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
			NULL,ADDR phkResult,ADDR lpdwDisposition 
		.if eax==ERROR_SUCCESS			
			invoke RegSetValueEx,phkResult,dwValue,
				NULL,REG_DWORD,lpDword,dwStrLength
			invoke RegCloseKey,phkResult	
			return TRUE			
		.endif

xor eax,eax
ret                   
SaveDword endp

GetDword proc	dwKey:DWORD,dwValueName:DWORD
		LOCAL dwSize:DWORD
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		LOCAL RType :DWORD
		LOCAL lpData:DWORD
		invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
			dwKey,NULL,NULL,
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,NULL,
			ADDR phkResult,ADDR lpdwDisposition
		.if eax==ERROR_SUCCESS
			mov eax,REG_DWORD	
			mov RType,eax
			invoke RegQueryValueEx,phkResult,
				dwValueName,NULL,ADDR RType,
				ADDR lpData,ADDR dwSize
			invoke RegCloseKey,phkResult
			return lpData
		.endif

xor eax,eax
ret
GetDword endp
;--====================binary values================================================--

SaveBinary proc  dwKey:DWORD,dwValue:DWORD,
		 lpDword:DWORD,dwStrLength:DWORD
		
		LOCAL phkResult	:DWORD
		LOCAL lpdwDisposition :DWORD
		invoke RegCreateKeyEx,HKEY_LOCAL_MACHINE,
			dwKey,NULL,NULL,
			REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
			NULL,ADDR phkResult,ADDR lpdwDisposition 
		.if eax==ERROR_SUCCESS			
			invoke RegSetValueEx,phkResult,dwValue,
				NULL,REG_BINARY,lpDword,dwStrLength
			invoke RegCloseKey,phkResult	
			return TRUE			
		.endif

xor eax,eax
ret                   
SaveBinary endp


GetBinary Proc bKey:DWORD,bValueName:DWORD
		LOCAL phkResult:DWORD		
		LOCAL lpData[128]:BYTE
		LOCAL lpSize:DWORD
		LOCAL RType:DWORD
	mov eax,REG_BINARY
	mov RType,eax
	invoke RegOpenKeyEx,HKEY_LOCAL_MACHINE,bKey,NULL,
			KEY_READ,ADDR phkResult
	.if eax==ERROR_SUCCESS
	invoke RegQueryValueEx,phkResult,bValueName,NULL,
			ADDR RType,ADDR lpData,ADDR lpSize
	invoke RegCloseKey,phkResult
	.endif

ret
GetBinary endp

;--================================================================--


